diff --git a/liboctave/array/CSparse.cc b/liboctave/array/CSparse.cc
--- a/liboctave/array/CSparse.cc
+++ b/liboctave/array/CSparse.cc
@@ -7753,7 +8696,13 @@ min (const SparseComplexMatrix& a, const
                 }
               else
                 {
-                  Complex tmp = octave::math::min (a.data (ja), b.data (jb));
+                  Complex tmp;
+                  if (includenan)
+                    tmp = a.data (ja) <= b.data (jb) ? a.data (ja)
+                          : (octave::math::isnan (a.data (ja)) ? a.data (ja)
+                             : b.data (jb));
+                  else
+                    tmp = octave::math::min (a.data (ja), b.data (jb));
                   if (tmp != 0.)
                     {
                       r.data (jx) = tmp;
@@ -7785,7 +8734,7 @@ min (const SparseComplexMatrix& a, const
 }
 
 SparseComplexMatrix
-max (const Complex& c, const SparseComplexMatrix& m)
+max (const Complex& c, const SparseComplexMatrix& m, bool includenan)
 {
   SparseComplexMatrix result;
 
@@ -7794,28 +8743,89 @@ max (const Complex& c, const SparseCompl
 
   EMPTY_RETURN_CHECK (SparseComplexMatrix);
 
+  if (octave::math::isnan (c))
+    {
+      if (includenan)
+        result = SparseComplexMatrix (nr, nc, c);
+      else
+        {
+          result = SparseComplexMatrix (m);
+          for (octave_idx_type j = 0; j < nc; j++)
+            for (octave_idx_type i = m.cidx (j); i < m.cidx (j+1); i++)
+              if (octave::math::isnan (m.data (i)))
+                result.data (i) = c;
+        }
+    }
   // Count the number of nonzero elements
-  if (octave::math::max (c, 0.) != 0.)
+  else if (octave::math::max (c, 0.) != 0.)
     {
       result = SparseComplexMatrix (nr, nc, c);
+      if (includenan)
+        {
+          for (octave_idx_type j = 0; j < nc; j++)
+            for (octave_idx_type i = m.cidx (j); i < m.cidx (j+1); i++)
+              if (m.data (i) > c || octave::math::isnan (m.data (i)))
+                result.xdata (m.ridx (i) + j * nr) = m.data (i);
+        }
+      else
+        {
+          for (octave_idx_type j = 0; j < nc; j++)
+            for (octave_idx_type i = m.cidx (j); i < m.cidx (j+1); i++)
+              result.xdata (m.ridx (i) + j * nr) =
+                octave::math::max (c, m.data (i));
+        }
+    }
+  else if (includenan)
+    result = SparseComplexMatrix (m);
+  else
+    {
+      result = SparseComplexMatrix (nr, nc, m.nnz ());
+
+      octave_idx_type ii = 0;
+      result.xcidx (0) = 0;
       for (octave_idx_type j = 0; j < nc; j++)
-        for (octave_idx_type i = m.cidx (j); i < m.cidx (j+1); i++)
-          result.xdata (m.ridx (i) + j * nr) = octave::math::max (c, m.data (i));
+        {
+          for (octave_idx_type i = m.cidx (j); i < m.cidx (j+1); i++)
+            if (! octave::math::isnan (m.data (i)))
+              {
+                result.xdata (ii) = m.data (i);
+                result.xridx (ii++) = m.ridx (i);
+              }
+          result.xcidx (j+1) = ii;
+        }
+
+      result.maybe_compress ();
     }
-  else
-    result = SparseComplexMatrix (m);
 
   return result;
 }
 
 SparseComplexMatrix
-max (const SparseComplexMatrix& m, const Complex& c)
-{
-  return max (c, m);
+max (const SparseComplexMatrix& m, const Complex& c, bool includenan)
+{
+  if (! octave::math::isnan (c))
+    return max (c, m, includenan);
+
+  if (! includenan)
+    return m;
+
+  octave_idx_type nr = m.rows ();
+  octave_idx_type nc = m.columns ();
+
+  EMPTY_RETURN_CHECK (SparseComplexMatrix);
+
+  SparseComplexMatrix result (nr, nc, c);
+  for (octave_idx_type j = 0; j < nc; j++)
+    for (octave_idx_type i = m.cidx (j); i < m.cidx (j+1); i++)
+      if (octave::math::isnan (m.data (i)))
+        result.xdata (m.ridx (i) + j * nr) = m.data (i);
+
+  return result;
 }
 
 SparseComplexMatrix
-max (const SparseComplexMatrix& a, const SparseComplexMatrix& b)
+max (const SparseComplexMatrix& a, const SparseComplexMatrix& b,
+     bool includenan)
 {
   SparseComplexMatrix r;
 
@@ -7845,7 +8855,11 @@ max (const SparseComplexMatrix& a, const
               octave_quit ();
               if ((! jb_lt_max) || (ja_lt_max && (a.ridx (ja) < b.ridx (jb))))
                 {
-                  Complex tmp = octave::math::max (a.data (ja), 0.);
+                  Complex tmp;
+                  if (octave::math::isnan (a.data (ja)) && ! includenan)
+                    tmp = 0.;
+                  else
+                    tmp = a.data (ja);
                   if (tmp != 0.)
                     {
                       r.ridx (jx) = a.ridx (ja);
@@ -7858,7 +8872,11 @@ max (const SparseComplexMatrix& a, const
               else if ((! ja_lt_max)
                        || (jb_lt_max && (b.ridx (jb) < a.ridx (ja))))
                 {
-                  Complex tmp = octave::math::max (0., b.data (jb));
+                  Complex tmp;
+                  if (octave::math::isnan (b.data (jb)) && ! includenan)
+                    tmp = 0.;
+                  else
+                    tmp = b.data (jb);
                   if (tmp != 0.)
                     {
                       r.ridx (jx) = b.ridx (jb);
@@ -7870,7 +8888,13 @@ max (const SparseComplexMatrix& a, const
                 }
               else
                 {
-                  Complex tmp = octave::math::max (a.data (ja), b.data (jb));
+                  Complex tmp;
+                  if (includenan)
+                    tmp = a.data (ja) >= b.data (jb) ? a.data (ja)
+                          : (octave::math::isnan (a.data (ja)) ? a.data (ja)
+                             : b.data (jb));
+                  else
+                    tmp = octave::math::max (a.data (ja), b.data (jb));
                   if (tmp != 0.)
                     {
                       r.data (jx) = tmp;
diff --git a/liboctave/array/CSparse.h b/liboctave/array/CSparse.h
--- a/liboctave/array/CSparse.h
+++ b/liboctave/array/CSparse.h
@@ -116,10 +116,19 @@ public:
 
   bool is_hermitian (void) const;
 
-  SparseComplexMatrix max (int dim = -1) const;
-  SparseComplexMatrix max (Array<octave_idx_type>& index, int dim = -1) const;
-  SparseComplexMatrix min (int dim = -1) const;
-  SparseComplexMatrix min (Array<octave_idx_type>& index, int dim = -1) const;
+  SparseComplexMatrix max (int dim = -1, bool includenan = false) const;
+  SparseComplexMatrix max (Array<octave_idx_type>& index,
+                           int dim = -1, bool includenan = false) const;
+  SparseComplexMatrix min (int dim = -1, bool includenan = false) const;
+  SparseComplexMatrix min (Array<octave_idx_type>& index,
+                           int dim = -1, bool includenan = false) const;
+
+  SparseComplexMatrix cummax (int dim = -1, bool includenan = false) const;
+  SparseComplexMatrix cummax (Array<octave_idx_type>& index,
+                              int dim = -1, bool includenan = false) const;
+  SparseComplexMatrix cummin (int dim = -1, bool includenan = false) const;
+  SparseComplexMatrix cummin (Array<octave_idx_type>& index,
+                              int dim = -1, bool includenan = false) const;
 
   SparseComplexMatrix& insert (const SparseComplexMatrix& a,
                                octave_idx_type r, octave_idx_type c);
@@ -527,18 +536,24 @@ extern OCTAVE_API SparseComplexMatrix op
                                                   const PermMatrix&);
 
 extern OCTAVE_API SparseComplexMatrix min (const Complex& c,
-                                           const SparseComplexMatrix& m);
+                                           const SparseComplexMatrix& m,
+                                           bool includenan = false);
 extern OCTAVE_API SparseComplexMatrix min (const SparseComplexMatrix& m,
-                                           const Complex& c);
+                                           const Complex& c,
+                                           bool includenan = false);
 extern OCTAVE_API SparseComplexMatrix min (const SparseComplexMatrix& a,
-                                           const SparseComplexMatrix& b);
+                                           const SparseComplexMatrix& b,
+                                           bool includenan = false);
 
 extern OCTAVE_API SparseComplexMatrix max (const Complex& c,
-                                           const SparseComplexMatrix& m);
+                                           const SparseComplexMatrix& m,
+                                           bool includenan = false);
 extern OCTAVE_API SparseComplexMatrix max (const SparseComplexMatrix& m,
-                                           const Complex& c);
+                                           const Complex& c,
+                                           bool includenan = false);
 extern OCTAVE_API SparseComplexMatrix max (const SparseComplexMatrix& a,
-                                           const SparseComplexMatrix& b);
+                                           const SparseComplexMatrix& b,
+                                           bool includenan = false);
 
 SPARSE_SMS_CMP_OP_DECLS (SparseComplexMatrix, Complex, OCTAVE_API)
 SPARSE_SMS_BOOL_OP_DECLS (SparseComplexMatrix, Complex, OCTAVE_API)
diff --git a/liboctave/array/dMatrix.cc b/liboctave/array/dMatrix.cc
--- a/liboctave/array/dMatrix.cc
+++ b/liboctave/array/dMatrix.cc
@@ -3026,28 +3026,148 @@ operator * (const Matrix& a, const Matri
     return T (nr, nc);
 
 Matrix
-min (double d, const Matrix& m)
+min (double d, const Matrix& m, bool includenan)
 {
   octave_idx_type nr = m.rows ();
   octave_idx_type nc = m.columns ();
 
   EMPTY_RETURN_CHECK (Matrix);
 
+  if (octave::math::isnan (d) && includenan)
+    return Matrix (nr, nc, d);
+
+  Matrix result (nr, nc);
+
+  if (includenan)
+    {
+      for (octave_idx_type j = 0; j < nc; j++)
+        for (octave_idx_type i = 0; i < nr; i++)
+          {
+            octave_quit ();
+            result(i, j) = d <= m(i, j) ? d : m(i, j);
+          }
+    }
+  else
+    {
+      for (octave_idx_type j = 0; j < nc; j++)
+        for (octave_idx_type i = 0; i < nr; i++)
+          {
+            octave_quit ();
+            result(i, j) = octave::math::min (d, m(i, j));
+          }
+    }
+
+  return result;
+}
+
+Matrix
+min (const Matrix& m, double d, bool includenan)
+{
+  if (! octave::math::isnan (d))
+    return min (d, m, includenan);
+
+  if (! includenan)
+    return m;
+
+  octave_idx_type nr = m.rows ();
+  octave_idx_type nc = m.columns ();
+
+  EMPTY_RETURN_CHECK (Matrix);
+
   Matrix result (nr, nc);
 
   for (octave_idx_type j = 0; j < nc; j++)
     for (octave_idx_type i = 0; i < nr; i++)
       {
         octave_quit ();
-        result(i, j) = octave::math::min (d, m(i, j));
+        result(i, j) = octave::math::isnan (m(i, j)) ? m(i, j) : d;
       }
 
   return result;
 }
 
 Matrix
-min (const Matrix& m, double d)
+min (const Matrix& a, const Matrix& b, bool includenan)
 {
+  octave_idx_type nr = a.rows ();
+  octave_idx_type nc = a.columns ();
+
+  if (nr != b.rows () || nc != b.columns ())
+    (*current_liboctave_error_handler)
+      ("two-arg min requires same size arguments");
+
+  EMPTY_RETURN_CHECK (Matrix);
+
+  Matrix result (nr, nc);
+
+  if (includenan)
+    {
+      for (octave_idx_type j = 0; j < nc; j++)
+        for (octave_idx_type i = 0; i < nr; i++)
+          {
+            octave_quit ();
+            result(i, j) = a(i, j) <= b(i, j) ? a(i, j)
+                           : (octave::math::isnan (a(i, j)) ? a(i, j)
+                              : b(i, j));
+          }
+    }
+  else
+    {
+      for (octave_idx_type j = 0; j < nc; j++)
+        for (octave_idx_type i = 0; i < nr; i++)
+          {
+            octave_quit ();
+            result(i, j) = octave::math::min (a(i, j), b(i, j));
+          }
+    }
+
+  return result;
+}
+
+Matrix
+max (double d, const Matrix& m, bool includenan)
+{
+  octave_idx_type nr = m.rows ();
+  octave_idx_type nc = m.columns ();
+
+  EMPTY_RETURN_CHECK (Matrix);
+
+  if (octave::math::isnan (d) && includenan)
+    return Matrix (nr, nc, d);
+
+  Matrix result (nr, nc);
+
+  if (includenan)
+    {
+      for (octave_idx_type j = 0; j < nc; j++)
+        for (octave_idx_type i = 0; i < nr; i++)
+          {
+            octave_quit ();
+            result(i, j) = d >= m(i, j) ? d : m(i, j);
+          }
+    }
+  else
+    {
+      for (octave_idx_type j = 0; j < nc; j++)
+        for (octave_idx_type i = 0; i < nr; i++)
+          {
+            octave_quit ();
+            result(i, j) = octave::math::max (d, m(i, j));
+          }
+    }
+
+  return result;
+}
+
+Matrix
+max (const Matrix& m, double d, bool includenan)
+{
+  if (! octave::math::isnan (d))
+    return max (d, m, includenan);
+
+  if (! includenan)
+    return m;
+
   octave_idx_type nr = m.rows ();
   octave_idx_type nc = m.columns ();
 
@@ -3059,96 +3179,46 @@ min (const Matrix& m, double d)
     for (octave_idx_type i = 0; i < nr; i++)
       {
         octave_quit ();
-        result(i, j) = octave::math::min (m(i, j), d);
+        result(i, j) = octave::math::isnan (m(i, j)) ? m(i, j) : d;
       }
 
   return result;
 }
 
 Matrix
-min (const Matrix& a, const Matrix& b)
+max (const Matrix& a, const Matrix& b, bool includenan)
 {
   octave_idx_type nr = a.rows ();
   octave_idx_type nc = a.columns ();
 
   if (nr != b.rows () || nc != b.columns ())
     (*current_liboctave_error_handler)
-      ("two-arg min requires same size arguments");
+      ("two-arg max requires same size arguments");
 
   EMPTY_RETURN_CHECK (Matrix);
 
   Matrix result (nr, nc);
 
-  for (octave_idx_type j = 0; j < nc; j++)
-    for (octave_idx_type i = 0; i < nr; i++)
-      {
-        octave_quit ();
-        result(i, j) = octave::math::min (a(i, j), b(i, j));
-      }
-
-  return result;
-}
-
-Matrix
-max (double d, const Matrix& m)
-{
-  octave_idx_type nr = m.rows ();
-  octave_idx_type nc = m.columns ();
-
-  EMPTY_RETURN_CHECK (Matrix);
-
-  Matrix result (nr, nc);
-
-  for (octave_idx_type j = 0; j < nc; j++)
-    for (octave_idx_type i = 0; i < nr; i++)
-      {
-        octave_quit ();
-        result(i, j) = octave::math::max (d, m(i, j));
-      }
-
-  return result;
-}
-
-Matrix
-max (const Matrix& m, double d)
-{
-  octave_idx_type nr = m.rows ();
-  octave_idx_type nc = m.columns ();
-
-  EMPTY_RETURN_CHECK (Matrix);
-
-  Matrix result (nr, nc);
-
-  for (octave_idx_type j = 0; j < nc; j++)
-    for (octave_idx_type i = 0; i < nr; i++)
-      {
-        octave_quit ();
-        result(i, j) = octave::math::max (m(i, j), d);
-      }
-
-  return result;
-}
-
-Matrix
-max (const Matrix& a, const Matrix& b)
-{
-  octave_idx_type nr = a.rows ();
-  octave_idx_type nc = a.columns ();
-
-  if (nr != b.rows () || nc != b.columns ())
-    (*current_liboctave_error_handler)
-      ("two-arg max requires same size arguments");
-
-  EMPTY_RETURN_CHECK (Matrix);
-
-  Matrix result (nr, nc);
-
-  for (octave_idx_type j = 0; j < nc; j++)
-    for (octave_idx_type i = 0; i < nr; i++)
-      {
-        octave_quit ();
-        result(i, j) = octave::math::max (a(i, j), b(i, j));
-      }
+  if (includenan)
+    {
+      for (octave_idx_type j = 0; j < nc; j++)
+        for (octave_idx_type i = 0; i < nr; i++)
+          {
+            octave_quit ();
+            result(i, j) = a(i, j) >= b(i, j) ? a(i, j)
+                           : (octave::math::isnan (a(i, j)) ? a(i, j)
+                              : b(i, j));
+          }
+    }
+  else
+    {
+      for (octave_idx_type j = 0; j < nc; j++)
+        for (octave_idx_type i = 0; i < nr; i++)
+          {
+            octave_quit ();
+            result(i, j) = octave::math::max (a(i, j), b(i, j));
+          }
+    }
 
   return result;
 }
diff --git a/liboctave/array/dMatrix.h b/liboctave/array/dMatrix.h
--- a/liboctave/array/dMatrix.h
+++ b/liboctave/array/dMatrix.h
@@ -375,13 +375,19 @@ extern OCTAVE_API Matrix xgemm (const Ma
 
 extern OCTAVE_API Matrix operator * (const Matrix& a, const Matrix& b);
 
-extern OCTAVE_API Matrix min (double d, const Matrix& m);
-extern OCTAVE_API Matrix min (const Matrix& m, double d);
-extern OCTAVE_API Matrix min (const Matrix& a, const Matrix& b);
+extern OCTAVE_API Matrix min (double d, const Matrix& m,
+                              bool includenan = false);
+extern OCTAVE_API Matrix min (const Matrix& m, double d,
+                              bool includenan = false);
+extern OCTAVE_API Matrix min (const Matrix& a, const Matrix& b,
+                              bool includenan = false);
 
-extern OCTAVE_API Matrix max (double d, const Matrix& m);
-extern OCTAVE_API Matrix max (const Matrix& m, double d);
-extern OCTAVE_API Matrix max (const Matrix& a, const Matrix& b);
+extern OCTAVE_API Matrix max (double d, const Matrix& m,
+                              bool includenan = false);
+extern OCTAVE_API Matrix max (const Matrix& m, double d,
+                              bool includenan = false);
+extern OCTAVE_API Matrix max (const Matrix& a, const Matrix& b,
+                              bool includenan = false);
 
 extern OCTAVE_API Matrix linspace (const ColumnVector& x1,
                                    const ColumnVector& x2,
diff --git a/liboctave/array/dNDArray.cc b/liboctave/array/dNDArray.cc
--- a/liboctave/array/dNDArray.cc
+++ b/liboctave/array/dNDArray.cc
@@ -677,51 +677,57 @@ NDArray::sumsq (int dim) const
 }
 
 NDArray
-NDArray::max (int dim) const
+NDArray::max (int dim, bool includenan) const
 {
-  return do_mx_minmax_op<double> (*this, dim, mx_inline_max);
+  return do_mx_minmax_op<double> (*this, dim, mx_inline_max, includenan);
 }
 
 NDArray
-NDArray::max (Array<octave_idx_type>& idx_arg, int dim) const
+NDArray::max (Array<octave_idx_type>& idx_arg, int dim, bool includenan) const
 {
-  return do_mx_minmax_op<double> (*this, idx_arg, dim, mx_inline_max);
+  return do_mx_minmax_op<double> (*this, idx_arg, dim, mx_inline_max,
+                                  includenan);
 }
 
 NDArray
-NDArray::min (int dim) const
+NDArray::min (int dim, bool includenan) const
 {
-  return do_mx_minmax_op<double> (*this, dim, mx_inline_min);
+  return do_mx_minmax_op<double> (*this, dim, mx_inline_min, includenan);
 }
 
 NDArray
-NDArray::min (Array<octave_idx_type>& idx_arg, int dim) const
+NDArray::min (Array<octave_idx_type>& idx_arg, int dim, bool includenan) const
 {
-  return do_mx_minmax_op<double> (*this, idx_arg, dim, mx_inline_min);
+  return do_mx_minmax_op<double> (*this, idx_arg, dim, mx_inline_min,
+                                  includenan);
 }
 
 NDArray
-NDArray::cummax (int dim) const
+NDArray::cummax (int dim, bool includenan) const
 {
-  return do_mx_cumminmax_op<double> (*this, dim, mx_inline_cummax);
+  return do_mx_cumminmax_op<double> (*this, dim, mx_inline_cummax, includenan);
 }
 
 NDArray
-NDArray::cummax (Array<octave_idx_type>& idx_arg, int dim) const
+NDArray::cummax (Array<octave_idx_type>& idx_arg,
+                 int dim, bool includenan) const
 {
-  return do_mx_cumminmax_op<double> (*this, idx_arg, dim, mx_inline_cummax);
+  return do_mx_cumminmax_op<double> (*this, idx_arg, dim, mx_inline_cummax,
+                                     includenan);
 }
 
 NDArray
-NDArray::cummin (int dim) const
+NDArray::cummin (int dim, bool includenan) const
 {
-  return do_mx_cumminmax_op<double> (*this, dim, mx_inline_cummin);
+  return do_mx_cumminmax_op<double> (*this, dim, mx_inline_cummin, includenan);
 }
 
 NDArray
-NDArray::cummin (Array<octave_idx_type>& idx_arg, int dim) const
+NDArray::cummin (Array<octave_idx_type>& idx_arg,
+                 int dim, bool includenan) const
 {
-  return do_mx_cumminmax_op<double> (*this, idx_arg, dim, mx_inline_cummin);
+  return do_mx_cumminmax_op<double> (*this, idx_arg, dim, mx_inline_cummin,
+                                     includenan);
 }
 
 NDArray
diff --git a/liboctave/array/dNDArray.h b/liboctave/array/dNDArray.h
--- a/liboctave/array/dNDArray.h
+++ b/liboctave/array/dNDArray.h
@@ -105,15 +105,19 @@ public:
   charNDArray concat (const charNDArray& rb,
                       const Array<octave_idx_type>& ra_idx);
 
-  NDArray max (int dim = -1) const;
-  NDArray max (Array<octave_idx_type>& index, int dim = -1) const;
-  NDArray min (int dim = -1) const;
-  NDArray min (Array<octave_idx_type>& index, int dim = -1) const;
+  NDArray max (int dim = -1, bool includenan = false) const;
+  NDArray max (Array<octave_idx_type>& index,
+               int dim = -1, bool includenan = false) const;
+  NDArray min (int dim = -1, bool includenan = false) const;
+  NDArray min (Array<octave_idx_type>& index,
+               int dim = -1, bool includenan = false) const;
 
-  NDArray cummax (int dim = -1) const;
-  NDArray cummax (Array<octave_idx_type>& index, int dim = -1) const;
-  NDArray cummin (int dim = -1) const;
-  NDArray cummin (Array<octave_idx_type>& index, int dim = -1) const;
+  NDArray cummax (int dim = -1, bool includenan = false) const;
+  NDArray cummax (Array<octave_idx_type>& index,
+                  int dim = -1, bool includenan = false) const;
+  NDArray cummin (int dim = -1, bool includenan = false) const;
+  NDArray cummin (Array<octave_idx_type>& index,
+                  int dim = -1, bool includenan = false) const;
 
   NDArray diff (octave_idx_type order = 1, int dim = -1) const;
 
diff --git a/liboctave/array/dSparse.cc b/liboctave/array/dSparse.cc
--- a/liboctave/array/dSparse.cc
+++ b/liboctave/array/dSparse.cc
@@ -186,14 +186,15 @@ SparseMatrix::insert (const SparseMatrix
 }
 
 SparseMatrix
-SparseMatrix::max (int dim) const
+SparseMatrix::max (int dim, bool includenan) const
 {
   Array<octave_idx_type> dummy_idx;
-  return max (dummy_idx, dim);
+  return max (dummy_idx, dim, includenan);
 }
 
 SparseMatrix
-SparseMatrix::max (Array<octave_idx_type>& idx_arg, int dim) const
+SparseMatrix::max (Array<octave_idx_type>& idx_arg,
+                   int dim, bool includenan) const
 {
   SparseMatrix result;
   dim_vector dv = dims ();
@@ -237,7 +238,16 @@ SparseMatrix::max (Array<octave_idx_type
               double tmp = data (i);
 
               if (octave::math::isnan (tmp))
-                continue;
+                {
+                  if (includenan)
+                    {
+                      idx_j = ridx (i);
+                      tmp_max = tmp;
+                      break;
+                    }
+                  else
+                    continue;
+                }
               else if (octave::math::isnan (tmp_max) || tmp > tmp_max)
                 {
                   idx_j = ridx (i);
@@ -246,7 +256,10 @@ SparseMatrix::max (Array<octave_idx_type
 
             }
 
-          idx_arg.elem (j) = octave::math::isnan (tmp_max) ? 0 : idx_j;
+          if (! includenan && octave::math::isnan (tmp_max))
+            idx_arg.elem (j) = 0;
+          else
+            idx_arg.elem (j) = idx_j;
           if (tmp_max != 0.)
             nel++;
         }
@@ -295,10 +308,17 @@ SparseMatrix::max (Array<octave_idx_type
               octave_idx_type ir = ridx (i);
               octave_idx_type ix = idx_arg.elem (ir);
               double tmp = data (i);
-
-              if (octave::math::isnan (tmp))
+              double best = elem (ir, ix);
+
+              if (includenan)
+                {
+                  if (! octave::math::isnan (best)
+                      && (octave::math::isnan (tmp) || tmp > best))
+                    idx_arg.elem (ir) = j;
+                }
+              else if (octave::math::isnan (tmp))
                 continue;
-              else if (ix == -1 || tmp > elem (ir, ix))
+              else if (octave::math::isnan (best) || tmp > best)
                 idx_arg.elem (ir) = j;
             }
         }
@@ -337,14 +357,15 @@ SparseMatrix::max (Array<octave_idx_type
 }
 
 SparseMatrix
-SparseMatrix::min (int dim) const
+SparseMatrix::min (int dim, bool includenan) const
 {
   Array<octave_idx_type> dummy_idx;
-  return min (dummy_idx, dim);
+  return min (dummy_idx, dim, includenan);
 }
 
 SparseMatrix
-SparseMatrix::min (Array<octave_idx_type>& idx_arg, int dim) const
+SparseMatrix::min (Array<octave_idx_type>& idx_arg,
+                   int dim, bool includenan) const
 {
   SparseMatrix result;
   dim_vector dv = dims ();
@@ -388,7 +409,16 @@ SparseMatrix::min (Array<octave_idx_type
               double tmp = data (i);
 
               if (octave::math::isnan (tmp))
-                continue;
+                {
+                  if (includenan)
+                    {
+                      idx_j = ridx (i);
+                      tmp_min = tmp;
+                      break;
+                    }
+                  else
+                    continue;
+                }
               else if (octave::math::isnan (tmp_min) || tmp < tmp_min)
                 {
                   idx_j = ridx (i);
@@ -397,7 +427,10 @@ SparseMatrix::min (Array<octave_idx_type
 
             }
 
-          idx_arg.elem (j) = octave::math::isnan (tmp_min) ? 0 : idx_j;
+          if (! includenan && octave::math::isnan (tmp_min))
+            idx_arg.elem (j) = 0;
+          else
+            idx_arg.elem (j) = idx_j;
           if (tmp_min != 0.)
             nel++;
         }
@@ -446,10 +479,17 @@ SparseMatrix::min (Array<octave_idx_type
               octave_idx_type ir = ridx (i);
               octave_idx_type ix = idx_arg.elem (ir);
               double tmp = data (i);
-
-              if (octave::math::isnan (tmp))
+              double best = elem (ir, ix);
+
+              if (includenan)
+                {
+                  if (! octave::math::isnan (best)
+                      && (octave::math::isnan (tmp) || tmp < best))
+                    idx_arg.elem (ir) = j;
+                }
+              else if (octave::math::isnan (tmp))
                 continue;
-              else if (ix == -1 || tmp < elem (ir, ix))
+              else if (octave::math::isnan (best) || tmp < best)
                 idx_arg.elem (ir) = j;
             }
         }
